import { memoize } from './memoize';

var applyFunctions = function applyFunctions(value, fn) {
  return Object.assign({}, value, fn(value) || {});
};

var memoizedFlow = function memoizedFlow(functions) {
  var flow = functions.map(memoize);
  return function (input) {
    return flow.reduce(applyFunctions, input);
  };
};

var memoizedFlowRight = function memoizedFlowRight(functions) {
  return memoizedFlow(Array.from(functions).reverse());
}; // aliases


var memoizedPipe = memoizedFlow;
var memoizedCompose = memoizedFlowRight;
export { memoizedFlowRight, memoizedCompose, memoizedFlow, memoizedPipe };