"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.memoizedPipe = exports.memoizedFlow = exports.memoizedCompose = exports.memoizedFlowRight = void 0;

var _memoize = require("./memoize");

var applyFunctions = function applyFunctions(value, fn) {
  return Object.assign({}, value, fn(value) || {});
};

var memoizedFlow = function memoizedFlow(functions) {
  var flow = functions.map(_memoize.memoize);
  return function (input) {
    return flow.reduce(applyFunctions, input);
  };
};

exports.memoizedFlow = memoizedFlow;

var memoizedFlowRight = function memoizedFlowRight(functions) {
  return memoizedFlow(Array.from(functions).reverse());
}; // aliases


exports.memoizedFlowRight = memoizedFlowRight;
var memoizedPipe = memoizedFlow;
exports.memoizedPipe = memoizedPipe;
var memoizedCompose = memoizedFlowRight;
exports.memoizedCompose = memoizedCompose;