"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shouldBePure = exports.shallBePure = exports.isThisPure = void 0;

var _functionDouble = _interopRequireDefault(require("function-double"));

var _utils = require("./utils");

var _memoize = require("./memoize");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var isThisPure = function isThisPure(fnCall) {
  var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'isThisPure';
  return (0, _utils.shallowTest)(fnCall(), fnCall(), false, message + ':result is not equal at [$KEYS$]');
};

exports.isThisPure = isThisPure;

var shallBePure = function shallBePure(fnCall) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$message = _ref.message,
      message = _ref$message === void 0 ? 'shouldBePure' : _ref$message,
      _ref$checkAffectedKey = _ref.checkAffectedKeys,
      checkAffectedKeys = _ref$checkAffectedKey === void 0 ? true : _ref$checkAffectedKey,
      _ref$isolatedCheck = _ref.isolatedCheck,
      isolatedCheck = _ref$isolatedCheck === void 0 ? false : _ref$isolatedCheck,
      _ref$onTrigger = _ref.onTrigger,
      onTrigger = _ref$onTrigger === void 0 ? false : _ref$onTrigger;

  var memoized = checkAffectedKeys ? (0, _memoize.memoize)(fnCall, {
    safe: true,
    isolatedCheck: isolatedCheck
  }) : (0, _memoize.memoize)(fnCall);
  var lastResult = null;
  var lastMemoizedResult = null;

  function functor() {
    var mresult = memoized.apply(void 0, arguments);
    var fresult = fnCall.apply(void 0, _toConsumableArray(memoized.cacheStatistics.lastCallArgs));
    functor.isPure = !memoized.cacheStatistics.memoizationDisabled;

    if (functor.isPure && lastResult) {
      if (lastResult !== fresult) {
        if (lastMemoizedResult === mresult) {
          functor.isPure = (0, _utils.shallowTest)(lastResult, fresult, onTrigger, message, fnCall, '`s result is not equal at [$KEYS$], while should be equal');
        }
      }
    }

    lastResult = fresult;
    lastMemoizedResult = mresult;
    return mresult;
  }

  return (0, _functionDouble["default"])(functor, fnCall);
};

exports.shallBePure = shallBePure;

var shouldBePure = function shouldBePure(fnCall, options) {
  return process.env.NODE_ENV === 'production' ? fnCall : shallBePure(fnCall, options);
};

exports.shouldBePure = shouldBePure;